var _excluded = ["menuData", "icon", "iconProps"],
    _excluded2 = ["style"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { Dropdown, Icon } from 'rlj-design';
import useHoverStyle from "./useHoverStyle";

/**
 * @description 下拉菜单,添加默认hover背景色
 * @param menuData // 下拉menu数据
 * @param icon 自定益icon
 * @param iconProps icon属性
 * @param reset Dropdown属性
 * @author xiLou
 * @date 2023/2/27
 * @returns
 * */
var DropdownHover = function DropdownHover(_ref) {
  var menuData = _ref.menuData,
      icon = _ref.icon,
      iconProps = _ref.iconProps,
      otherDropdown = _objectWithoutProperties(_ref, _excluded);

  var _useHoverStyle = useHoverStyle({}),
      _useHoverStyle2 = _slicedToArray(_useHoverStyle, 3),
      _ = _useHoverStyle2[0],
      setHoverVisible = _useHoverStyle2[1],
      hoverStyle = _useHoverStyle2[2];

  var _ref2 = iconProps || {},
      style = _ref2.style,
      otherIcon = _objectWithoutProperties(_ref2, _excluded2);

  return /*#__PURE__*/React.createElement(Dropdown, _extends({
    placement: "bottomRight",
    menu: {
      items: menuData
    },
    onOpenChange: function onOpenChange(open) {
      return setHoverVisible(open);
    },
    overlayStyle: {
      minWidth: 120
    }
  }, otherDropdown), /*#__PURE__*/React.createElement("div", {
    className: hoverStyle
  }, icon ? /*#__PURE__*/React.cloneElement(icon, _objectSpread({}, iconProps)) : /*#__PURE__*/React.createElement(Icon, _extends({
    type: "moreTransverse",
    style: _objectSpread({
      fontSize: 16
    }, style)
  }, otherIcon))));
};

export default DropdownHover;