function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { Button, Space, Popover, Icon } from 'rlj-design';
import "./index.less";
import { PREFIX_CLS } from "../../constants/dictionary";
var prefixCls = "".concat(PREFIX_CLS, "-pop-confirm");

var PopConfirm = function PopConfirm(_ref) {
  var children = _ref.children,
      onOk = _ref.onOk,
      onOkText = _ref.onOkText,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'delete' : _ref$type,
      title = _ref.title,
      content = _ref.content,
      PopoverProps = _ref.PopoverProps;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var handleClose = function handleClose() {
    setOpen(false);
  };

  var handleOk = function handleOk() {
    onOk(handleClose);
  };

  var contentRender = /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-container")
  }, /*#__PURE__*/React.createElement("div", {
    className: 'icon-div'
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "warningAreality",
    className: type === 'delete' ? 'icon' : 'icon-warning'
  }), /*#__PURE__*/React.createElement("span", {
    className: 'title'
  }, title || '确定删除吗？')), content && /*#__PURE__*/React.createElement("div", {
    className: 'desc'
  }, content), /*#__PURE__*/React.createElement("div", {
    className: 'btn'
  }, /*#__PURE__*/React.createElement(Space, {
    size: 8
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: handleClose,
    size: 'small',
    style: {
      width: 48
    }
  }, "\u53D6\u6D88"), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    danger: type === 'delete',
    onClick: handleOk,
    size: 'small',
    style: {
      width: 48
    }
  }, onOkText || '删除'))));
  return /*#__PURE__*/React.createElement(Popover, _extends({
    content: contentRender,
    trigger: "click",
    showArrow: false,
    open: open,
    overlayClassName: "".concat(prefixCls, "-popover"),
    onOpenChange: function onOpenChange(visible) {
      return setOpen(visible);
    }
  }, PopoverProps), children);
};

export { PopConfirm };