import { MutableRefObject } from 'react';
import type { TableProps, TableColumns, TableUnit } from './index';
import { HtmlRefType, RenderModuleType } from './base';
import { ColDataType, ColumnInfoType, GridRefType } from './display';
interface ISelectOneRow<T> extends TableColumns<T> {
    rowIndex?: number;
    data?: TableUnit;
}
export interface ReduxDataGenericsType<T> {
    copyDrags?: {
        rowIndex?: number;
        dataIndex?: number;
        maxRowIndex?: number;
    };
    loadingExpandId?: string;
    selectOneRow?: ISelectOneRow<T>;
    copyCursor?: ISelectOneRow<T>;
    rowHeight?: number;
}
export declare type ReduxDataType = ReduxDataGenericsType<TableUnit>;
export interface ExcelContextGenericsType<T> extends ReduxDataGenericsType<T> {
    hoverRowHighlight?: boolean;
    crosswalk?: boolean;
    defaultShowCtx?: string;
    expandConfig: TableProps<T>['expandConfig'];
    editableConfig: TableProps<T>['editableConfig'];
    modalRef: MutableRefObject<HtmlRefType>;
    excelBox: MutableRefObject<HtmlRefType>;
    dragLine: MutableRefObject<HtmlRefType>;
    gridRef: MutableRefObject<GridRefType>;
    moveLine: MutableRefObject<HtmlRefType>;
    leftLine: MutableRefObject<HtmlRefType>;
    rightLine: MutableRefObject<HtmlRefType>;
    salaryBox: MutableRefObject<HtmlRefType>;
    renderModule?: RenderModuleType;
    colData: ColDataType;
    columnInfo: ColumnInfoType;
    dataSource: T[];
    summation?: T;
    totalNum?: number;
    width: number;
    height: number;
    rowKey: string;
    rowSelection: TableProps<T>['rowSelection'];
    changeTable: (data: any, type: string) => void;
    changeColumns: (index: number, childIndex: number, value: any, type: string) => void;
}
export declare type ExcelContextType = ExcelContextGenericsType<TableUnit>;
export interface DataContextType {
    [key: string]: any;
    columnWidth: (index: number) => number;
    rowHeight: (index: number) => number;
    changeRedux: (param: any) => void;
    mergeHoverIndex?: number;
}
export {};
