function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { getRowKeys, getKey, getErrorDisabled } from "./utils/tools";
// true => 阻止渲染
// false => 可以渲染
export var areEqual = function areEqual(a, b) {
  var _a$excelCtx, _a$excelCtx2, _b$excelCtx, _a$excelCtx3, _a$excelCtx$expandCon, _a$excelCtx4, _a$excelCtx4$expandCo, _b$excelCtx2, _b$excelCtx$expandCon, _b$excelCtx3, _b$excelCtx3$expandCo, _b$excelCtx4, _b$excelCtx4$rowSelec, _a$excelCtx5, _a$excelCtx5$rowSelec;

  // 使用renderModule-always， 允许一直需要渲染更新
  if (((_a$excelCtx = a.excelCtx) === null || _a$excelCtx === void 0 ? void 0 : _a$excelCtx.renderModule) === 'always' || a.currentColumn.renderModule === 'always') {
    return false;
  } // console.log(a, b);


  var aRedux = _objectSpread(_objectSpread({}, a.excelCtx), a.dataCtx);

  var bRedux = _objectSpread(_objectSpread({}, b.excelCtx), b.dataCtx); // 自带默认参数的getRowKeys函数


  var getRowKey = function getRowKey(param) {
    return getRowKeys(aRedux === null || aRedux === void 0 ? void 0 : aRedux.rowKey, param);
  }; // 获取redux内的数据


  var getData = function getData() {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var source = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    try {
      return data.reduce(function (m, n) {
        return m[n];
      }, source);
    } catch (_unused) {
      return {};
    }
  }; // 判断行，true => 变化|可以渲染   false => 不变化|不能渲染


  var validateRow = function validateRow(param) {
    var rowBase = param.rowBase,
        rowData = param.rowData;

    if (rowBase === 'rowIndex') {
      if (typeof rowData === 'string' && getKey(a.currentColumn) === rowData) {
        return true;
      }

      if (a.rowIndex === getData(rowData, aRedux) || b.rowIndex === getData(rowData, bRedux)) {
        return true;
      }
    }

    if (rowBase === 'rowKey') {
      if (getRowKey(a.currentData) === getRowKey(getData(rowData, aRedux)) || getRowKey(b.currentData) === getRowKey(getData(rowData, bRedux))) {
        return true;
      }
    }

    if (rowBase === 'rowIndexArea' && rowData) {
      if (a.rowIndex >= getData(rowData[0], aRedux) && a.rowIndex <= getData(rowData[1], aRedux) || b.rowIndex >= getData(rowData[0], bRedux) && b.rowIndex <= getData(rowData[1], bRedux)) {
        return true;
      }
    }

    return false;
  }; // 判断列，true => 变化   false => 不变化


  var validateCol = function validateCol(param) {
    var colData = param.colData,
        colBase = param.colBase;

    if (colBase === 'colIndex') {
      if (a.columnIndex === getData(colData, aRedux) || b.columnIndex === getData(colData, bRedux)) {
        return true;
      }
    }

    if (colBase === 'dataIndex') {
      if (typeof colData === 'string' && getKey(a.currentColumn) === colData) {
        return true;
      }

      if (getKey(a.currentColumn) === getKey(getData(colData, aRedux)) || getKey(b.currentColumn) === getKey(getData(colData, bRedux))) {
        return true;
      }
    }

    if (colBase === 'colIndexArea') {
      if (a.columnIndex >= getData(colBase[0], aRedux) && a.columnIndex <= getData(colBase[1], aRedux) || b.columnIndex >= getData(colBase[0], bRedux) && b.columnIndex <= getData(colBase[1], bRedux)) {
        return true;
      }
    }

    return false;
  };

  var validateCell = function validateCell(param) {
    return validateRow(param) && validateCol(param);
  };

  var validate = function validate(param) {
    var type = param.type;
    if (type === 'row' && validateRow(param)) return true;
    if (type === 'col' && validateCol(param)) return true;
    return ['cell', 'area'].includes(type) && validateCell(param);
  }; // 1. 更新单元格 id 和 dataIndex
  // 2. 更新整行 id  getRowKeys 需要考虑data.mergeArr(表格合并单元格，因为children被折叠用掉了)
  // 3. 更新整列 dataIndex getKey 需要考虑data.children(表头合并单元格)
  // 使用redux里面的哪个值 去获取指定的单元格，
  // 获取单元格需要 getKey 和 getRowKeys 这两个方法，
  // 同时getKey方法还需要遍历data.children才可以
  // hover效果显示允许条件


  if (validate({
    type: 'row',
    rowData: ['mergeHoverIndex'],
    rowBase: 'rowIndex'
  })) {
    return false;
  } // 选中效果允许条件


  if (validate({
    type: 'cell',
    rowData: ['selectOneRow', 'data'],
    rowBase: 'rowKey',
    colData: ['selectOneRow'],
    colBase: 'dataIndex'
  })) {
    return false;
  }

  if (validate({
    type: 'cell',
    rowData: ['selectOneRow', 'rowIndex'],
    rowBase: 'rowIndex',
    colData: 'rowPrefixSp',
    colBase: 'dataIndex'
  })) {
    return false;
  }

  if (validate({
    type: 'area',
    rowData: [['copyDrags', 'rowIndex'], ['copyDrags', 'maxRowIndex']],
    rowBase: 'rowIndexArea',
    colData: ['copyCursor'],
    colBase: 'dataIndex'
  })) {
    return false;
  } // ============================== 内置条件 ==============================
  // 内置条件 = 折叠后的三角小图标变化;


  if (((_a$excelCtx2 = a.excelCtx) === null || _a$excelCtx2 === void 0 ? void 0 : _a$excelCtx2.loadingExpandId) !== ((_b$excelCtx = b.excelCtx) === null || _b$excelCtx === void 0 ? void 0 : _b$excelCtx.loadingExpandId) && (((_a$excelCtx3 = a.excelCtx) === null || _a$excelCtx3 === void 0 ? void 0 : _a$excelCtx3.loadingExpandId) === a.currentData[(_a$excelCtx$expandCon = (_a$excelCtx4 = a.excelCtx) === null || _a$excelCtx4 === void 0 ? void 0 : (_a$excelCtx4$expandCo = _a$excelCtx4.expandConfig) === null || _a$excelCtx4$expandCo === void 0 ? void 0 : _a$excelCtx4$expandCo.expandKey) !== null && _a$excelCtx$expandCon !== void 0 ? _a$excelCtx$expandCon : 'expandId'] || ((_b$excelCtx2 = b.excelCtx) === null || _b$excelCtx2 === void 0 ? void 0 : _b$excelCtx2.loadingExpandId) === b.currentData[(_b$excelCtx$expandCon = (_b$excelCtx3 = b.excelCtx) === null || _b$excelCtx3 === void 0 ? void 0 : (_b$excelCtx3$expandCo = _b$excelCtx3.expandConfig) === null || _b$excelCtx3$expandCo === void 0 ? void 0 : _b$excelCtx3$expandCo.expandKey) !== null && _b$excelCtx$expandCon !== void 0 ? _b$excelCtx$expandCon : 'expandId']) || a.currentData.expandStatus !== b.currentData.expandStatus) {
    return false;
  } // 内置条件 = 编辑条件下errors disabled 变化


  var curErrorData, nextErrorData;
  var aEditConfig = aRedux === null || aRedux === void 0 ? void 0 : aRedux.editableConfig;

  if (aEditConfig !== null && aEditConfig !== void 0 && aEditConfig.editable) {
    var _aEditConfig$infos = aEditConfig.infos,
        aInfos = _aEditConfig$infos === void 0 ? [] : _aEditConfig$infos,
        _aEditConfig$disabled = aEditConfig.disabled,
        aDisabled = _aEditConfig$disabled === void 0 ? [] : _aEditConfig$disabled;
    curErrorData = getErrorDisabled(aInfos.concat(aDisabled), getKey(a.currentColumn), getRowKey(a.currentData));
  }

  var bEditConfig = bRedux === null || bRedux === void 0 ? void 0 : bRedux.editableConfig;

  if (bEditConfig !== null && bEditConfig !== void 0 && bEditConfig.editable) {
    var _bEditConfig$infos = bEditConfig.infos,
        bInfos = _bEditConfig$infos === void 0 ? [] : _bEditConfig$infos,
        _bEditConfig$disabled = bEditConfig.disabled,
        bDisabled = _bEditConfig$disabled === void 0 ? [] : _bEditConfig$disabled;
    nextErrorData = getErrorDisabled(bInfos.concat(bDisabled), getKey(b.currentColumn), getRowKey(b.currentData));
  }

  if (curErrorData || nextErrorData) {
    return false;
  } // 内置条件 = 多选栏 一直可以刷新 （这里没写好，内部每个值都需要外部的值，无法限制渲染）


  if (getKey(a.currentColumn) === 'rowSelection') {
    return false;
  } // 内置条件 = 数据行选中变化


  if ((_b$excelCtx4 = b.excelCtx) !== null && _b$excelCtx4 !== void 0 && (_b$excelCtx4$rowSelec = _b$excelCtx4.rowSelection) !== null && _b$excelCtx4$rowSelec !== void 0 && _b$excelCtx4$rowSelec.selectedRowKeys.includes(getRowKey(a.currentData)) || (_a$excelCtx5 = a.excelCtx) !== null && _a$excelCtx5 !== void 0 && (_a$excelCtx5$rowSelec = _a$excelCtx5.rowSelection) !== null && _a$excelCtx5$rowSelec !== void 0 && _a$excelCtx5$rowSelec.selectedRowKeys.includes(getRowKey(a.currentData))) {
    return false;
  } // 内置条件 = 宽度变化


  if (a.currentColumn.width !== b.currentColumn.width) return false; // if (a.excelCtx?.rowKey !== 'id') {
  //   if (
  //     getRowKey(a.currentData) !== getRowKey(b.currentData) ||
  //     Object.keys(a.currentData).length !== Object.keys(b.currentData).length
  //   ) {
  //     return false;
  //   }
  //   // 内置条件 = 数据变化
  //   return Object.is(
  //     a.currentData[getKey(a.currentColumn)],
  //     b.currentData[getKey(b.currentColumn)],
  //   );
  // } else {

  var flag = true;

  if (Object.keys(a.currentData).length !== Object.keys(b.currentData).length) {
    flag = false;
  } else {
    Object.keys(a.currentData).forEach(function (key) {
      if (_typeof(a.currentData[key]) !== 'object' || a.currentData[key] === null) {
        if (a.currentData[key] !== b.currentData[key]) {
          flag = false;
        }
      }
    });
  }

  return flag; // }
};